## spark 2010.0.deb

=== Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the entire Spark Toolset source distribution
# Build the SPARK Toolset on NT, Solaris, Linux or MacOS X
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET := $(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
   TARGET:=Windows
endif

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXEEXTN:=.exe
endif

# Sun.
ifeq (${TARGET},SunOS)
    EXEEXTN:=
endif

# Linux.
ifeq (${TARGET},Linux)
    EXEEXTN:=
endif

# Darwin (Mac OS X).
ifeq (${TARGET},Darwin)
    EXEEXTN:=
endif

################################################################################
# TARGETS
################################################################################

# Build all of the tools, copy them to bin, and clean up.
all: makeall copyall cleanall

################################################################################
# BUILDS
################################################################################

makeall:
	make -C sparklalr
	make -C examiner
	make -C simplifier
	make -C wraputility
	make -C checker
	make -C pogs
	make -C sparkformat
	make -C sparkmake
	make -C sparksimp
	make -C victor
	make -C victor_wrapper

copyall: copywindowsfiles
	cp ./examiner/spark${EXEEXTN}           ./bin/
	cp ./simplifier/spadesimp${EXEEXTN}     ./bin/
	cp ./simplifier/zombiescope${EXEEXTN}   ./bin/
	cp ./wraputility/wrap_utility${EXEEXTN} ./bin/
	cp ./checker/checker${EXEEXTN}          ./bin/
	cp ./pogs/pogs${EXEEXTN}                ./bin/
	cp ./sparkformat/sparkformat${EXEEXTN}  ./bin/
	cp ./sparkmake/sparkmake${EXEEXTN}      ./bin/
	cp ./sparksimp/sparksimp${EXEEXTN}      ./bin/
	cp ./victor_wrapper/victor${EXEEXTN}    ./bin/
ifeq (${TARGET},Linux)
	# We only build victor on Linux platforms.
	cp ./victor/alt-ergo/alt-ergo.opt       ./bin/alt-ergo${EXEEXTN}
	cp ./victor/vct/bin/vct${EXEEXTN}       ./bin/
	cp ./victor/alt-ergo/smt_prelude.mlw    ./share/spark/
endif
	cp ./victor/vct/run/prelude.fdl         ./share/spark/
	cp ./victor/vct/run/prelude.rul         ./share/spark/
	cp ./victor/vct/run/divmod.rul          ./share/spark/

ifeq (${TARGET},Windows)
copywindowsfiles:
	# Copy manifests for SICStus tools.
	cp ./simplifier/spadesimp${EXEEXTN}.manifest   ./bin/
	cp ./simplifier/zombiescope${EXEEXTN}.manifest ./bin/
	cp ./checker/checker${EXEEXTN}.manifest        ./bin/
	# Copy the required DLLs into bin.
	cp ./dlls/*                                    ./bin/

else
copywindowsfiles:
endif

cleanall:
	make -C sparklalr      clean
	make -C examiner       clean
	make -C simplifier     clean
	make -C wraputility    clean
	make -C checker        clean
	make -C pogs           clean
	make -C sparkformat    clean
	make -C sparkmake      clean
	make -C sparksimp      clean
	make -C victor         clean
	make -C victor_wrapper clean

reallycleanall:
	rm -f ./bin/*
	rm -f ./share/spark/*
	make -C sparklalr      reallyclean
	make -C examiner       reallyclean
	make -C simplifier     reallyclean
	make -C wraputility    reallyclean
	make -C checker        reallyclean
	make -C pogs           reallyclean
	make -C sparkformat    reallyclean
	make -C sparkmake      reallyclean
	make -C sparksimp      reallyclean
	make -C victor         clean
	make -C victor_wrapper reallyclean

analyseall:
	-make -C sparklalr      examine
	-make -C examiner       examine
	-make -C simplifier     spxref
	-make -C wraputility    examine
	-make -C checker        spxref
	-make -C pogs           examine
	-make -C sparkformat    examine
	-make -C sparkmake      examine
	-make -C victor_wrapper examine

analyseallplain:
	-make -C sparklalr      examine
	-make -C examiner       examine
	-make -C simplifier     spxrefplain
	-make -C wraputility    examine
	-make -C checker        spxrefplain
	-make -C pogs           examine
	-make -C sparkformat    examine
	-make -C sparkmake      examine
	-make -C victor_wrapper examine

# Regenerate the reference results.
# (May be used to capture analysis of the current code base).
generaterereference: analyseallplain
	cp ./sparklalr/vcg/sparklalr.rep      ./analyse/referenceanalysis/sparklalr.rep
	cp ./examiner/vcg/mainunits95.rep     ./analyse/referenceanalysis/examiner.rep
	cp ./simplifier/spxref_undefined.txt  ./analyse/referenceanalysis/simplifier_spxref_undefined.txt
	cp ./wraputility/vcg/wrap_utility.rep ./analyse/referenceanalysis/wrap_utility.rep
	cp ./checker/spxref_undefined.txt     ./analyse/referenceanalysis/checker_spxref_undefined.txt
	cp ./pogs/vcg/pogs.rep                ./analyse/referenceanalysis/pogs.rep
	cp ./sparkformat/vcg/sparkformat.rep  ./analyse/referenceanalysis/sparkformat.rep
	cp ./sparkmake/vcg/sparkmake.rep      ./analyse/referenceanalysis/sparkmake.rep
	cp ./victor_wrapper/vcg/victor.rep    ./analyse/referenceanalysis/victor.rep

################################################################################
# END-OF-FILE

=== examiner/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the Examiner
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.SUFFIXES:

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=spark

# Location of root.
ROOT:=..

# Location of SPARKLALR parser generator binary
SPARKLALR:=${ROOT}/sparklalr/sparklalr

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET:=$(shell uname -s)
GCC_TARGET:=$(shell gcc -dumpmachine)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
    TARGET:=Windows
endif

################################################################################
# DYNAMIC DEPENDENCIES
################################################################################

# EXAMINERSIZE
# ------------
# Large (Build to handle large programs)
# Mega  (Build to handle mega programs)
EXAMINERSIZE:=Large

# Every *.ad? file is required, except those excluded below.
# Note that some of these excluded files may not be present due to a make
# clean before building the source distribution. However, they are still
# referenced here to make their exclusion explicit.

# Do not distribute files that must be prepped.
SPARK_PREPED:=examinerconstants.ads filesystem.adb

# Do not distribute files that are generated by the parser.
SPARK_PARSER:=spsymbols.ads spparsergoto.adb spparsergoto.ads sprelations.adb \
	sprelations.ads spparseractions.adb spparseractions.ads \
	spproductions.ads spexpectedsymbols.adb spexpectedsymbols.ads SPARK.PAR

FILES_GRAMMAR:=SPARK.LLA

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Location of customer lib
CUSTOMER_LIB:=${ROOT}/lib/spark/current

# Location of common.
COMMON:=${ROOT}/common

# Options to submit to gnatprep.
# DEBUG: The Examiner raises a fatal error during self-analysis with
#        Source_Reference pragmas in place. Thus, the handy "-r" option
#        is removed until the error is fixed.
PREP_OPTS:=-c

# Files containing platform specific code that is handled by gnatprep
PREP_TARGETS:=${SPARK_PREPED} \
	indexmanager-cache.adb indexmanager-cache.shb \
	sli-xref.adb sli-xref.shb

# Debug info file produced by sparklalr (so they can be cleaned up)
PARSER_DEBUG:=SPARK.DGN SPARK.DSC SPARK.EKO SPARK.SYM SPARK.ACT

# Common compiler options.
COMMON_OPTS:=-g -gnatwae -gnat05 -gnatwl -gnaty3abefhiklnprt -I${CUSTOMER_LIB} -I${COMMON}/versioning -gnatf -k
GNATMAKE_OPTS:=${COMMON_OPTS} -O1
GCC_OPTS:=-fstack-check
BIND_OPTS:=-E

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXE_EXTN:=.exe
    LINK_ARGS:=-Xlinker --stack=0x10000000,0x100000
    PREP_TARGET:=Intel_WinNT
    ifeq (${GCC_TARGET},i686-pc-mingw32)
        ADDRESS_SIZE:=32
    else
        ADDRESS_SIZE:=64
    endif
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXE_EXTN:=
    LINK_ARGS:=
    PREP_TARGET:=SPARC_Solaris
    ADDRESS_SIZE:=32
endif

# Linux.
ifeq (${TARGET},Linux)
    EXE_EXTN:=
    LINK_ARGS:=
    PREP_TARGET:=Intel_Linux
    ifeq (${GCC_TARGET},x86_64-pc-linux-gnu)
        ADDRESS_SIZE:=64
    else
        ADDRESS_SIZE:=32
    endif
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    EXE_EXTN:=
    LINK_ARGS:=
    PREP_TARGET:=Darwin
    ADDRESS_SIZE:=64

    # The full-blown implementation of symbolic tracebacks is not
    # working on GNAT Pro at the moment, so
    # force local compilation of dummy GNAT.Traceback.Symbolic in
    # examiner/g-trasym.adb
    GNATMAKE_OPTS:=-a ${GNATMAKE_OPTS}
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: prep parser
	gnatmake ${GNATMAKE_OPTS} examiner -o ${OUTPUT_NAME}${EXE_EXTN} -cargs ${GCC_OPTS} -bargs ${BIND_OPTS} -largs ${LINK_ARGS}

examine: prep parser
	-spark -report=mainunits95.rep -plain      @${OUTPUT_NAME}.smf

examinexml: prep parser
	-spark -report=mainunits95.xml -plain -xml @${OUTPUT_NAME}.smf

# Building parser
# ===============

parser: ${SPARK_PARSER}

${SPARK_PARSER}: ${FILES_GRAMMAR}
	# -p = Operate as parser
	# -s = Perform self-pack
	# -m = Accept multi comp
	# -v = Verbose
	# -du = Activate debug feature: dump memory
	${SPARKLALR} spark -p -s -m -v -du
	gnatchop -w SPARK.PAR

# Platform specific prepping
# ==========================

prep: ${PREP_TARGETS}

%.ads: %.aps
	gnatprep ${PREP_OPTS} -DExaminerSize=${EXAMINERSIZE} -DTarget=${PREP_TARGET} -DAddress_Size=${ADDRESS_SIZE} $< $@

%.adb: %.apb
	gnatprep ${PREP_OPTS} -DExaminerSize=${EXAMINERSIZE} -DTarget=${PREP_TARGET} -DAddress_Size=${ADDRESS_SIZE} $< $@

indexmanager-cache.adb: indexmanager-cache.SHADOW.adb
	gnatprep ${PREP_OPTS} -r -DSPARK=False $< $@

indexmanager-cache.shb: indexmanager-cache.SHADOW.adb
	gnatprep ${PREP_OPTS} -DSPARK=True $< $@

sli-xref.adb: sli-xref.SHADOW.adb
	gnatprep ${PREP_OPTS} -r -DSPARK=False $< $@

sli-xref.shb: sli-xref.SHADOW.adb
	gnatprep ${PREP_OPTS} -DSPARK=True $< $@

# Cleaning code base
# ==================

clean: residueclean standardclean

reallyclean: clean targetclean parserclean prepclean vcclean

residueclean:
	rm -f ${PARSER_DEBUG}

standardclean:
	rm -f *.o *.ali

targetclean:
	rm -f ${OUTPUT_NAME}${EXE_EXTN}
	rm -f b~*.ad[sb]

parserclean:
	rm -f ${SPARK_PARSER}

prepclean:
	rm -f ${PREP_TARGETS}

vcclean:
	-find vcg -type f -name "*.vcg" -delete
	-find vcg -type f -name "*.fdl" -delete
	-find vcg -type f -name "*.rls" -delete
	-find vcg -type f -name "*.siv" -delete
	-find vcg -type f -name "*.slg" -delete
	-find vcg -type f -name "*.sli" -delete
	-find vcg -type f -name "*.lsb" -delete
	-find vcg -type f -name "*.log" -delete
	rm -f vcg/*.rep vcg/mainunits95.xml
	-find vcg -depth -mindepth 1 -type d | grep -v -e '/\.svn' | xargs rmdir --ignore-fail-on-non-empty

################################################################################
# END-OF-FILE

=== pogs/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for POGS
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.SUFFIXES:

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=pogs

# Location of root.
ROOT:=..

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET:=$(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
    TARGET:=Windows
endif

################################################################################
# DYNAMIC DEPENDENCIES
################################################################################

# Every *.ad? file is required, except those excluded below.
# Note that some of these excluded files may not be present due to a make
# clean before building the source distribution. However, they are still
# referenced here to make their exclusion explicit.

# Do not distribute files that must be prepped.
SPARK_PREPED:=oscommandline.adb

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Location of customer lib
CUSTOMER_LIB:=${ROOT}/lib/spark/current

# Location of common.
COMMON:=${ROOT}/common

# Options to submit to gnatprep.
# DEBUG: The Examiner raises a fatal error during self-analysis with
#        Source_Reference pragmas in place. Thus, the handy "-r" option
#        is removed until the error is fixed.
PREP_OPTS:=-c

# Files containing platform specific code that is handled by gnatprep
PREP_TARGETS:=${SPARK_PREPED}

# Common compiler options.
COMMON_OPTS:=-g -gnatwae -gnat05 -gnatwl -gnaty3abefhiklnprt -I${CUSTOMER_LIB} -I${COMMON}/versioning -I${ROOT}/examiner -gnatf -k
GNATMAKE_OPTS:=${COMMON_OPTS} -O1
BIND_OPTS:=-E

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXE_EXTN:=.exe
    PREP_TARGET:=Intel_WinNT
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXE_EXTN:=
    PREP_TARGET:=SPARC_Solaris
endif

# Linux.
ifeq (${TARGET},Linux)
    EXE_EXTN:=
    PREP_TARGET:=Intel_Linux
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    EXE_EXTN:=
    PREP_TARGET:=Darwin

    # The full-blown implementation of symbolic tracebacks is not
    # working on GNAT Pro at the moment, so
    # force local compilation of dummy GNAT.Traceback.Symbolic in
    # examiner/g-trasym.adb
    GNATMAKE_OPTS:=-a ${GNATMAKE_OPTS}
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep
	gnatmake ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o ${OUTPUT_NAME}${EXE_EXTN} -bargs ${BIND_OPTS}

examine: preamble prep
	-spark -plain @${OUTPUT_NAME}.smf

preamble:
	make -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep: ${PREP_TARGETS}
	make -C ${ROOT}/examiner prep

%.ads: %.aps
	gnatprep ${PREP_OPTS} -DTarget=${PREP_TARGET} $< $@

%.adb: %.apb
	gnatprep ${PREP_OPTS} -DTarget=${PREP_TARGET} $< $@

# Cleaning code base
# ==================

clean: residueclean standardclean

reallyclean: clean targetclean vcclean preamble
	make -C ${ROOT}/examiner reallyclean

residueclean:
	rm -f ${PREP_TARGETS}

standardclean:
	rm -f *.o *.ali

targetclean:
	rm -f ${OUTPUT_NAME}${EXE_EXTN}
	rm -f b~*.ad[sb]

vcclean:
	-find vcg -type f -name "*.vcg" -delete
	-find vcg -type f -name "*.fdl" -delete
	-find vcg -type f -name "*.rls" -delete
	-find vcg -type f -name "*.siv" -delete
	-find vcg -type f -name "*.slg" -delete
	-find vcg -type f -name "*.sli" -delete
	-find vcg -type f -name "*.lsb" -delete
	-find vcg -type f -name "*.log" -delete
	rm -f vcg/${OUTPUT_NAME}.rep
	-find vcg -depth -mindepth 1 -type d | grep -v -e '/\.svn' | xargs rmdir --ignore-fail-on-non-empty

################################################################################
# END-OF-FILE

=== simplifier/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================


################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the Simplifier
# Build the Simplifier on NT, Solaris, Linux or MacOS X
################################################################################


################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUTNAME_SIMPLIFIER:=spadesimp
OUTPUTNAME_ZOMBIESCOPE:=zombiescope

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this makefile is being run on.
TARGET := $(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
   TARGET:=Windows
endif


################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

ROOT:=..
COMMON:=${ROOT}/common
SICSTUSLIBS:=codesio
SICSTUSSWITCHES:=-f --nologo --noinfo
SAVEXTN:=.sav

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXEEXTN:=.exe

    # Do not embedded a manifest, as these can contain false dependencies.
    # Instead, use manually generated, and correct, external manifest.
    SPLD_CONF:=--no-embed-manifest
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXEEXTN:=
    SPLD_CONF:=
endif

# Linux.
ifeq (${TARGET},Linux)
    EXEEXTN:=
    SPLD_CONF:=
endif

# Darwin (Mac OS X).
ifeq (${TARGET},Darwin)
    # Modify PATH to pick up Apple's gcc before GNAT Pro.
    PATH:=/usr/bin:${PATH}
    EXEEXTN:=
    SPLD_CONF:=
endif


################################################################################
# TARGETS
################################################################################

all: ${OUTPUTNAME_SIMPLIFIER}${EXEEXTN} ${OUTPUTNAME_ZOMBIESCOPE}${EXEEXTN}

# Note that the build assumes PATH is set to include SICStus binaries and (on
# Windows) MS VC Tools and LIB and INCLUDE are set to point at MS VC libraries
# and includes respectively.

${OUTPUTNAME_SIMPLIFIER}${EXEEXTN}: manifest
	sicstus ${SICSTUSSWITCHES} --goal "compile('simplifier.pro'), add_system_toolname('Simplifier'), buildsav_simplifier."
	spld ${SPLD_CONF} -o ${OUTPUTNAME_SIMPLIFIER}${EXEEXTN} --static --resources=${OUTPUTNAME_SIMPLIFIER}${SAVEXTN}=/${OUTPUTNAME_SIMPLIFIER}${SAVEXTN},${SICSTUSLIBS}

${OUTPUTNAME_ZOMBIESCOPE}${EXEEXTN}: manifest_zombiescope
	sicstus ${SICSTUSSWITCHES} --goal "compile('simplifier.pro'), add_system_toolname('ZombieScope'), buildsav_zombiescope."
	spld ${SPLD_CONF} -o ${OUTPUTNAME_ZOMBIESCOPE}${EXEEXTN} --static --resources=${OUTPUTNAME_ZOMBIESCOPE}${SAVEXTN}=/${OUTPUTNAME_ZOMBIESCOPE}${SAVEXTN},${SICSTUSLIBS}

# Manifest only required on Windows.
ifeq ($(findstring ${TARGET},Windows),${TARGET})

manifest:
	cp ${OUTPUTNAME_SIMPLIFIER}.windows.manifest ${OUTPUTNAME_SIMPLIFIER}${EXEEXTN}.manifest

manifest_zombiescope:
	cp ${OUTPUTNAME_ZOMBIESCOPE}.windows.manifest ${OUTPUTNAME_ZOMBIESCOPE}${EXEEXTN}.manifest

else
manifest:
manifest_zombiescope:
endif

build_profiled_without_flexlm:
	sicstus ${SICSTUSSWITCHES} --goal "prolog_flag(compiling, _, profiledcode), compile('simplifier.pro'), buildsav_profiled."
	spld ${SPLD_CONF} -o ${OUTPUTNAME}${EXEEXTN} --static --resources=${OUTPUTNAME}${SAVEXTN}=/${OUTPUTNAME}${SAVEXTN},${SICSTUSLIBS}
	chmod a+rx ${OUTPUTNAME}${EXEEXTN}

spxref:
	spxref -R -i spxref.pro simplifier.pro -w spxref_warning.txt -x spxref_cross.txt -m spxref_ported.txt -u spxref_undefined.txt

spxrefplain:
	spxref -R -i spxref.pro simplifier.pro -w spxref_warning.txt -x spxref_cross.txt -m spxref_ported.txt -u spxref_undefined.txt
	# Normalize anonymous prolog variables.
	sed -e 's/_[0-9][0-9]*/_/g' spxref_undefined.txt > spxref_undefined.txt.tmp
	mv spxref_undefined.txt.tmp spxref_undefined.txt

clean:
	rm -f spadesimp.sav spadesimp.exp spadesimp.ilk spadesimp.lib spadesimp.pdb
	rm -f zombiescope.sav zombiescope.exp zombiescope.ilk zombiescope.lib zombiescope.pdb

reallyclean: clean
	rm -f ${OUTPUTNAME_SIMPLIFIER}${EXEEXTN}
	rm -f ${OUTPUTNAME_SIMPLIFIER}${EXEEXTN}.manifest
	rm -f ${OUTPUTNAME_ZOMBIESCOPE}${EXEEXTN}
	rm -f ${OUTPUTNAME_ZOMBIESCOPE}${EXEEXTN}.manifest
	rm -f spxref_warning.txt spxref_cross.txt spxref_ported.txt spxref_undefined.txt


################################################################################
# END-OF-FILE

=== sparkformat/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for SPARKFormat
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.SUFFIXES:

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=sparkformat

# Location of root.
ROOT:=..

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET:=$(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
    TARGET:=Windows
endif

################################################################################
# DYNAMIC DEPENDENCIES
################################################################################

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Location of customer lib
CUSTOMER_LIB:=${ROOT}/lib/spark/current

# Location of common.
COMMON:=${ROOT}/common

# Common compiler options.
COMMON_OPTS:=-g -gnatwae -gnat05 -gnatwl -gnaty3abefhiklnprt -I${CUSTOMER_LIB} -I${COMMON}/versioning -I${ROOT}/examiner -gnatf -k
GNATMAKE_OPTS:=${COMMON_OPTS} -O1
BIND_OPTS:=-E

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXE_EXTN:=.exe
    LINK_ARGS:=-Xlinker --stack=0x10000000,0x100000
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXE_EXTN:=
    LINK_ARGS:=
endif

# Linux.
ifeq (${TARGET},Linux)
    EXE_EXTN:=
    LINK_ARGS:=
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    EXE_EXTN:=
    LINK_ARGS:=

    # The full-blown implementation of symbolic tracebacks is not
    # working on GNAT Pro at the moment, so
    # force local compilation of dummy GNAT.Traceback.Symbolic in
    # examiner/g-trasym.adb
    GNATMAKE_OPTS:=-a ${GNATMAKE_OPTS}
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep parser
	gnatmake ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o ${OUTPUT_NAME}${EXE_EXTN} -bargs ${BIND_OPTS} -largs ${LINK_ARGS}

examine: preamble prep parser
	-spark -plain @${OUTPUT_NAME}.smf

preamble:
	make -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep:
	make -C ${ROOT}/examiner prep

parser:
	make -C ${ROOT}/examiner parser

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean preamble
	make -C ${ROOT}/examiner reallyclean

standardclean:
	rm -f *.o *.ali

targetclean:
	rm -f ${OUTPUT_NAME}${EXE_EXTN}
	rm -f b~*.ad[sb]

vcclean:
	-find vcg -type f -name "*.vcg" -delete
	-find vcg -type f -name "*.fdl" -delete
	-find vcg -type f -name "*.rls" -delete
	-find vcg -type f -name "*.siv" -delete
	-find vcg -type f -name "*.slg" -delete
	-find vcg -type f -name "*.sli" -delete
	-find vcg -type f -name "*.lsb" -delete
	-find vcg -type f -name "*.log" -delete
	rm -f vcg/${OUTPUT_NAME}.rep
	-find vcg -depth -mindepth 1 -type d | grep -v -e '/\.svn' | xargs rmdir --ignore-fail-on-non-empty

################################################################################
# END-OF-FILE

=== sparklalr/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the SPARKLALR parser
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.SUFFIXES:

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=sparklalr

# Location of root.
ROOT:=..

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET:=$(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
    TARGET:=Windows
endif

################################################################################
# DYNAMIC DEPENDENCIES
################################################################################

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Location of customer lib
CUSTOMER_LIB:=${ROOT}/lib/spark/current

# Location of common.
COMMON:=${ROOT}/common

# Common compiler options.
COMMON_OPTS:=-g -gnatwae -gnat05 -gnatwl -gnaty3abefhiklnprt -I${CUSTOMER_LIB} -gnatf -k
GNATMAKE_OPTS:=${COMMON_OPTS} -O1
BIND_OPTS:=-E

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXE_EXTN:=.exe
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXE_EXTN:=
endif

# Linux.
ifeq (${TARGET},Linux)
    EXE_EXTN:=
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    EXE_EXTN:=
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}:
	gnatmake ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o ${OUTPUT_NAME}${EXE_EXTN} -bargs ${BIND_OPTS}

examine:
	-spark -plain @${OUTPUT_NAME}.smf

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean

standardclean:
	rm -f *.o *.ali

targetclean:
	rm -f ${OUTPUT_NAME}${EXE_EXTN}
	rm -f b~*.ad[sb]

vcclean:
	-find vcg -type f -name "*.vcg" -delete
	-find vcg -type f -name "*.fdl" -delete
	-find vcg -type f -name "*.rls" -delete
	-find vcg -type f -name "*.siv" -delete
	-find vcg -type f -name "*.slg" -delete
	-find vcg -type f -name "*.sli" -delete
	-find vcg -type f -name "*.lsb" -delete
	-find vcg -type f -name "*.log" -delete
	rm -f vcg/${OUTPUT_NAME}.rep
	-find vcg -depth -mindepth 1 -type d | grep -v -e '/\.svn' | xargs rmdir --ignore-fail-on-non-empty

################################################################################
# END-OF-FILE

=== sparkmake/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for SPARKMake
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.SUFFIXES:

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=sparkmake

# Location of root.
ROOT:=..

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET:=$(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
    TARGET:=Windows
endif

################################################################################
# DYNAMIC DEPENDENCIES
################################################################################

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Location of customer lib
CUSTOMER_LIB:=${ROOT}/lib/spark/current

# Location of common.
COMMON:=${ROOT}/common

# Common compiler options.
COMMON_OPTS:=-g -gnatwae -gnat05 -gnatwl -gnaty3abefhiklnprt -I${CUSTOMER_LIB} -I${COMMON}/versioning -I${ROOT}/examiner -gnatf -k
GNATMAKE_OPTS:=${COMMON_OPTS} -O1
BIND_OPTS:=-E

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXE_EXTN:=.exe
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXE_EXTN:=
endif

# Linux.
ifeq (${TARGET},Linux)
    EXE_EXTN:=
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    EXE_EXTN:=

    # The full-blown implementation of symbolic tracebacks is not
    # working on GNAT Pro at the moment, so
    # force local compilation of dummy GNAT.Traceback.Symbolic in
    # examiner/g-trasym.adb
    GNATMAKE_OPTS:=-a ${GNATMAKE_OPTS}
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep parser
	gnatmake ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o ${OUTPUT_NAME}${EXE_EXTN} -bargs ${BIND_OPTS}

examine: preamble prep parser
	-spark -plain @${OUTPUT_NAME}.smf

preamble:
	make -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep:
	make -C ${ROOT}/examiner prep

parser:
	make -C ${ROOT}/examiner parser

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean preamble
	make -C ${ROOT}/examiner reallyclean

standardclean:
	rm -f *.o *.ali

targetclean:
	rm -f ${OUTPUT_NAME}${EXE_EXTN}
	rm -f b~*.ad[sb]

vcclean:
	-find vcg -type f -name "*.vcg" -delete
	-find vcg -type f -name "*.fdl" -delete
	-find vcg -type f -name "*.rls" -delete
	-find vcg -type f -name "*.siv" -delete
	-find vcg -type f -name "*.slg" -delete
	-find vcg -type f -name "*.sli" -delete
	-find vcg -type f -name "*.lsb" -delete
	-find vcg -type f -name "*.log" -delete
	rm -f vcg/${OUTPUT_NAME}.rep
	-find vcg -depth -mindepth 1 -type d | grep -v -e '/\.svn' | xargs rmdir --ignore-fail-on-non-empty

################################################################################
# END-OF-FILE

=== victor/Makefile ===
#-------------------------------------------------------------------------------
#  (C) Altran Praxis Limited
#===============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for Victor
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.SUFFIXES:

################################################################################
# BUILD CONFIGURATION
################################################################################

VICTOR_OUTPUT_NAME:=vct

ALT_ERGO:=alt-ergo
VICTOR:=vct

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET := $(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
   TARGET:=Windows
endif

################################################################################
# DYNAMIC DEPENDENCIES
################################################################################

FILES_MAKE:=Makefile

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXE_EXTN:=.exe
    CPUS:=${NUMBER_OF_PROCESSORS}
    TAR:=tar
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXE_EXTN:=
    CPUS:=${SPARKCPUS}
    TAR:=gtar
endif

# Linux.
ifeq (${TARGET},Linux)
    EXE_EXTN:=
    CPUS:=${SPARKCPUS}
    TAR:=tar
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    EXE_EXTN:=
    CPUS:=${SPARKCPUS}
    TAR:=tar
endif

# If CPUS is not explicitly set, default to 1.
ifeq (${CPUS},)
    CPUS:=1
endif

################################################################################
# TARGETS
################################################################################

ALT_ERGO_DIR=$(shell ${TAR} ztf ${ALT_ERGO}-*.tar.gz | head -1)

# Target to build vct and alt-ergo
ifeq (${TARGET},Linux)
all: ${VICTOR}-target ${ALT_ERGO}-target
else
all:
endif

${VICTOR}-target:
	# Don't build Victor in parallel. Missing dependencies in the Makefile.
	make -C ${VICTOR}/src STATIC_GMP=1

${ALT_ERGO}-target: ${ALT_ERGO}
	cd ${ALT_ERGO} && ./configure
	make -j ${CPUS} -C ${ALT_ERGO}

${ALT_ERGO}:
	${TAR} zxvf ${ALT_ERGO}-*.tar.gz
	mv ${ALT_ERGO_DIR} ${ALT_ERGO}

# Build source tarball
# ====================

# S=Source locations. (where the files are found)
S_ALT_ERGO:=${ALT_ERGO}
S_VICTOR:=${VICTOR}

# T=Target locations. (where the files are put)
T_VICTOR:=victor

# Note that a simple copy will copy all the .svn stuff and we do not
# want to include that.
source:
	# Ensure a clean start
	rm -rf ${T_VICTOR}
	# Create directories for source tree.
	mkdir -p ${T_VICTOR}
	# Create the directory structure
	-find ${S_VICTOR} -name .svn -prune -o \( -type d \) -exec mkdir ${T_VICTOR}/'{}' ';'
	# Copy all files
	-find ${S_VICTOR} -name .svn -prune -o \( -type f \) -exec cp '{}' ${T_VICTOR}/'{}' ';'
	cp ${ALT_ERGO}-*.tar.gz ${T_VICTOR}
	cp ${FILES_MAKE} ${T_VICTOR}/
	# Create tar file from source tree.
	${TAR} -cf ${T_VICTOR}.tar ./${T_VICTOR}
	# Delete source tree.
	rm -rf ${T_VICTOR}

clean:
	rm -Rf ${ALT_ERGO}
	-make -C ${VICTOR}/src clean
	rm -f ${VICTOR}/bin/${VICTOR_OUTPUT_NAME}${EXE_EXTN}

=== victor_wrapper/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the Victor Wrapper
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.SUFFIXES:

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=victor

# Location of root.
ROOT:=..

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET:=$(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
    TARGET:=Windows
endif

################################################################################
# DYNAMIC DEPENDENCIES
################################################################################

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Location of customer lib
CUSTOMER_LIB:=${ROOT}/lib/spark/current

# Location of common.
COMMON:=${ROOT}/common

# Common compiler options.
COMMON_OPTS:=-g -gnatwae -gnat05 -gnatwl -gnaty3abefhiklnprt -I${CUSTOMER_LIB} -I${COMMON}/versioning -I${ROOT}/examiner -gnatf -k
GNATMAKE_OPTS:=${COMMON_OPTS} -O1
BIND_OPTS:=-E

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXE_EXTN:=.exe
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXE_EXTN:=
endif

# Linux.
ifeq (${TARGET},Linux)
    EXE_EXTN:=
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    EXE_EXTN:=
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep
	gnatmake ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o ${OUTPUT_NAME}${EXE_EXTN} -bargs ${BIND_OPTS}

examine: preamble prep
	-spark -plain @${OUTPUT_NAME}.smf

preamble:
	make -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep:
	make -C ${ROOT}/examiner prep

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean preamble
	make -C ${ROOT}/examiner reallyclean

standardclean:
	rm -f *.o *.ali

targetclean:
	rm -f ${OUTPUT_NAME}${EXE_EXTN}
	rm -f b~*.ad[sb]

vcclean:
	-find vcg -type f -name "*.vcg" -delete
	-find vcg -type f -name "*.fdl" -delete
	-find vcg -type f -name "*.rls" -delete
	-find vcg -type f -name "*.siv" -delete
	-find vcg -type f -name "*.slg" -delete
	-find vcg -type f -name "*.sli" -delete
	-find vcg -type f -name "*.lsb" -delete
	-find vcg -type f -name "*.log" -delete
	-find vcg -type f -name "*.dpc" -delete
	-find vcg -type f -name "*.sdp" -delete
	-find vcg -type f -name "*.zlg" -delete
	-find vcg -type f -name "*.zsl" -delete
	rm -f vcg/${OUTPUT_NAME}.rep
	-find vcg -depth -mindepth 1 -type d | grep -v -e '/\.svn' | xargs rmdir --ignore-fail-on-non-empty

################################################################################
# END-OF-FILE

=== wraputility/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the wraputility
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.SUFFIXES:

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=wrap_utility

# Location of root.
ROOT:=..

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET:=$(shell uname -s)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
    TARGET:=Windows
endif

################################################################################
# DYNAMIC DEPENDENCIES
################################################################################

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Location of customer lib
CUSTOMER_LIB:=${ROOT}/lib/spark/current

# Location of common.
COMMON:=${ROOT}/common

# Common compiler options.
COMMON_OPTS:=-g -gnatwae -gnat05 -gnatwl -gnaty3abefhiklnprt -I${CUSTOMER_LIB} -I${ROOT}/examiner -gnatf -k
GNATMAKE_OPTS:=${COMMON_OPTS} -O1
BIND_OPTS:=-E

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    EXE_EXTN:=.exe
endif

# Solaris.
ifeq (${TARGET},SunOS)
    EXE_EXTN:=
endif

# Linux.
ifeq (${TARGET},Linux)
    EXE_EXTN:=
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    EXE_EXTN:=
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep
	gnatmake ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o ${OUTPUT_NAME}${EXE_EXTN} -bargs ${BIND_OPTS}

examine: preamble prep
	-spark -plain @${OUTPUT_NAME}.smf

preamble:
	make -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep:
	make -C ${ROOT}/examiner prep

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean preamble
	make -C ${ROOT}/examiner reallyclean

standardclean:
	rm -f *.o *.ali

targetclean:
	rm -f ${OUTPUT_NAME}${EXE_EXTN}
	rm -f b~*.ad[sb]

vcclean:
	-find vcg -type f -name "*.vcg" -delete
	-find vcg -type f -name "*.fdl" -delete
	-find vcg -type f -name "*.rls" -delete
	-find vcg -type f -name "*.siv" -delete
	-find vcg -type f -name "*.slg" -delete
	-find vcg -type f -name "*.sli" -delete
	-find vcg -type f -name "*.lsb" -delete
	-find vcg -type f -name "*.log" -delete
	rm -f vcg/${OUTPUT_NAME}.rep
	-find vcg -depth -mindepth 1 -type d | grep -v -e '/\.svn' | xargs rmdir --ignore-fail-on-non-empty

################################################################################
# END-OF-FILE

=== victor/vct/run/Makefile ===
#=============================================================================
# Make rules for running Victor
#=============================================================================
# This file is part of Victor: a SPARK VC Translator and Prover Driver.

# Copyright (C) 2009, 2010 University of Edinburgh

# Author(s): Paul Jackson

# Victor is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# Victor is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# A copy of the GNU General Public License V3 can be found in file
# LICENSE.txt and online at http://www.gnu.org/licenses/.
#==========================================================================


#=============================================================================
# User customisation
#=============================================================================


# Stand-alone executables for SMT solvers
# ----------------------------------------

# The default assumption is that the solver executables are on the current
# path.  As desired, absolute paths can be set up for each here.

Z3=z3
YICES=yices
CVC3=cvc3
SIMPLIFY=simplify
ALT_ERGO=alt-ergo

# Locations of SPARK VC files
# ---------------------------

# Targets are set up below that can easily be used for different sets
# of VC units.  For a set of VC units named <vc-set>, the targets
# assume the definition here of:
#
# 1. A Make variable "<vc-set>_prefix" for the root of the directory tree 
#    for the set.

# 2. A Make variable "<vc-set>_units" that names the .lis file listing 
#    the unit names and, for each unit, specifies options.  See the
#    user manual "Unit listing input file" section for details on how to
#    format this file.
#
# 3. A phony target "vcset-<vc-set>" against which to check matches for
#    the pattern rules below for running Victor.

# Make variables for VC sets distributed with Victor.

autop_prefix =  ../vc/autop/code
autop_units =   ../vc/autop/autop-units.lis
.PHONY: vcset-autop

hilton_prefix =  ../vc/hilton/code
hilton_units =    ../vc/hilton/hilton-units.lis
.PHONY: vcset-hilton


#=============================================================================
# Make features used
#=============================================================================
#
# Automatic variables commonly used in commands are:
# 
# $@ : Set to whole rule target
#
# $* : Set to the stem of the target (the stem is the string that the 
#      % matches in the target)

# Rules are made generic with respect to the VC set by using GNU Make
# pattern rules. (rules with % in target)

# Use of phony rather than real targets ensures that rules always
# fires when make called.


#=============================================================================
# Variables settable in make calls
#=============================================================================
# 
# The behaviour of Victor runs can be customised by setting make variables
# when invoking make.
#
#
# Syntax for setting variable names is:
#
#  make <target>  <vname1>=<val1> .. <vnamek>=<valk>
#
# When make variables are set in this way, any definition in the makefile
# is overridden.  Variable descriptions are given below in rough order
# of likely interest to users.
#
#
# Format of documentation 
# <Title>
#
# <Varname> [=<value> : <type>]   [<default>]  <suffix>
#
# <Description>
# 
# where
# <value>  : suggestive name for value.
# <type>   : One of `int' or `string' or `fixed'. or `bool'.
#            `fixed' means fixed point. E.g. 1.5  0.03
#            `bool' values are `true' and `false'.
#
# <suffix> : Suffix added to report name. Usually includes <value> if
#            significant.

#----------------------------------------------------------------------------
# Timeout for file-level interface
#
# T=<time> : int (10)  -t<time>
#
# Set timeout in seconds for solver with file-level interface.
# Uses process ulimit facility to set timeout.

#----------------------------------------------------------------------------
# CVC3 timeout
#
# CT=<time> : int (100)  -ct<time>
#
# Set timeout in units of 0.1 seconds for CVC3.  Works for both API and SMTLIB
# file-level interfaces.  Uses CVC3's internal timeout capabilities.
# If CT is set, T is ignored.

#----------------------------------------------------------------------------
# Use unfused conclusions 
#
# U=<val> : bool (false)  u- | f-
# 
# If <val> is true, run solvers on each goal slice at a time. If false,
# fuse conclusions together so there is one solver run per goal.
# If conclusions are unfused, add a u- prefix to report name.
# If conclusions are fused, add an f- prefix to report name.
# 
# Prefix rather than suffix added to report file name so that summary
# files for each kind of run are separated out when files listed in
# order.

#----------------------------------------------------------------------------
# Directory for reports
#
# OUTDIR=<dirname> : string  (out)
#
# Directory for .csv .log .sum report files

#----------------------------------------------------------------------------
# Arithmetic abstraction and simplification
#
# L=  <val> : bool (false)  -lin
# LEC=<val> : bool (false)  -lin-ec
# LAE=<val> : bool (false)  -lin-ae
# EC=<val>  : bool (false)  -ec
# AE=<val>  : bool (false)  -ae

# Various options for coping with solvers that don't support non-linear
# arithmetic (e.g. Yices).  At most one should be selected.

# * EC substitutes out symbolic integer constants, constants introduced
#      with definition c = k where c is a constant, k an integer literal.
# * AE Applies EC first and then does some partial evaluation and 
#      simplification, trying to make more multiplications linear.
# * L abstracts non-linear multiplications.  Applied after EC or AE in LEC
#      and LAE.


#----------------------------------------------------------------------------
# siv file
#
# SIV=<val> : bool (false)  -siv
# 
# If <val> is true, read goals from .siv files output by Simplifier
# rather than .vcg files output by Examiner, and add -siv suffix to report
# names.

#----------------------------------------------------------------------------
# Track trivial goals
#
# TG=<val> : bool (false) -tg
#
# `Trivial goals' are goals in .vcg or .siv files with no hypotheses or
# conclusions and listed as simply "*** true".
#
# If <val> is true, Victor includes a line in the .csv report file for each
# of these goals.


#----------------------------------------------------------------------------
# Report file suffix
#
# SFX=<suffix> : string  ""
#
# Add an extra suffix to report file name.  Use this option when some
# parameter affecting behaviour is changed in a way that doesn't
# otherwise add a suffix.


#----------------------------------------------------------------------------
# Iterate calls of solver to increase precision of runtime measurements.
#
# RD=<count> : int (1)   -rd<count>
# RC=<count> : int (1)   -rc<count>
#
# RD ("Repeat Drive") for use with API interface mode, RC ("Repeat
# Check") for use with smtlib/simplify interface mode.

#----------------------------------------------------------------------------
# Focus on single unit and possibly single goal
#
# UNIT=<unitname> : string   ("")
# GOAL=<goalnumber> : int    (0)
#
# Setting UNIT overrides any units file listing of units to run on.
# A default GOAL number of 0 indicates to try all goals.

#----------------------------------------------------------------------------
# Set threshold for symbolic numeric constants
#
# SYM_CONSTS=<threshold> : int (100000)
#
# Use with Simplify solver to attempt to avoid overflows.

#----------------------------------------------------------------------------
# Options for SMTLIB and Simplify translations
# 
# A=<Aoption> : int (0)
# B=<Boption> : int (0)
# C=<Coption> : int (0)
# D=<Doption> : int (0)
# E=<Eoption> : int (0)
# F=<Foption> : int (0)
# G=<Goption> : int (0)
#
# Options A-F select translation alternatives and should not affect
# completeness.  Option G affects how array and record extensionality is
# dealt with.  The default for G is not to add in any support for
# extensionality. 
#
# See Makefile-prelude.mk for details on these options.

#=============================================================================
# Include prelude
#=============================================================================
# The prelude defines make variables that assemble together sets of
# Victor options for different solvers and different customisation
# options.

include Makefile-prelude.mk

#=============================================================================
# Utility rules
#=============================================================================

# Rebuild Victor

src:
	cd ../src; make vct; cd ../run





#============================================================================
# Rules for running Victor
#============================================================================


# Naming conventions

# Make targets:
#   <unit-set>-<interface-m><prover>
#
# Output files:
# <prefix><unit-set>-<interface-m><prover><suffix>.[log|csv|sum]

# <prefix> = 
# f-: conclusions fused
# u-: conclusions unfused

# <interface-m> =
# a: API
# s: SMT-Lib and file-level 
# p: Simplify and file-level
# i: Isabelle/HOL and file-level
# d: dummy

# <prover>=
# a: Alt-Ergo
# c: cvc3
# y: yices
# p: simplify
# z: z3
# n: none

# <suffix> = suffices added by setting make variables that customise
#            Victor behaviour

# e.g. 
#
#   make autop-ac
#
# Runs CVC3 via API on autop VC set and creates report files
#
#  f-autop-ac.vlg
#  f-autop-ac.vct
#  f-autop-ac.vsm
#
# in OUTDIR directory (by default ./out).

# Also below we use <prefix><unit-set>-xx when analysing Simplifier 
# behaviour.

#----------------------------------------------------------------------------
# API interface mode
#-------------------

%-ac: vcset-%
	vct \
           $(std_options) \
           $(api_cvc3_options)\


%-ay: vcset-%
	vct \
           $(std_options)\
           $(api_yices_options) \

#----------------------------------------------------------------------------
# SMTLIB file interface mode
#---------------------------

%-sa: vcset-%
	vct \
            $(std_options)\
            $(smtlib_options) \
            -prover-command=$(ALT_ERGO) \


%-sc: vcset-%
	vct \
            $(std_options)\
            $(smtlib_options) \
            -prover-command='$(CVC3) -lang smt $(cvc3_timeout_flag)'\

%-sy: vcset-%
	vct \
            $(std_options)\
            $(smtlib_options) \
            -abstract-nonlin-times\
            -logic=AUFLIA\
            -prover-command='$(YICES) -smt'\


%-sz: vcset-%
	vct \
            $(std_options)\
            $(smtlib_options) \
            -prover-command='$(Z3) -smt' \


#----------------------------------------------------------------------------
# Simplify file interface mode
#-----------------------------

%-pp: vcset-%
	vct \
            $(std_options)\
            $(simplify_interface_options) \
            -sym-consts=$(SYM_CONSTS) \
            -prover-command='$(SIMPLIFY) -nosc' \


# As %-pp, but use z3

%-pz: vcset-%
	vct \
            $(std_options)\
            $(simplify_interface_options) \
            -sym-consts=$(SYM_CONSTS) \
            -prover-command='$(Z3) -s' \


# As %-pz but no threshold

%-pz-nt: vcset-%
	vct \
            $(std_options)\
            $(simplify_interface_options) \
            -prover-command='$(Z3) -s' \


#----------------------------------------------------------------------------
# Isabelle file interface mode
#-----------------------------

%-in: vcset-%

=== debian/changelog ===
spark (2010.0.deb-6) unstable; urgency=medium

  * Fix mistakes in the manpages
  * Build-depend and depend on swi-prolog-nox (>= 5.10.4~), this fixes
    breakage with new prolog version. Hopefully it can be replaced with
    something better in the future
  * Urgency medium to allow spark to migrate to testing at the same time
    as swi-prolog

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 19 Jun 2011 18:28:06 +0200

spark (2010.0.deb-5) unstable; urgency=low

  * Add parallel build support (only for gnatmake invocations)

 -- Євгеній Мещеряков <eugen@debian.org>  Sat, 04 Jun 2011 01:47:58 +0200

spark (2010.0.deb-4) unstable; urgency=low

  * Refresh checker-remove-close_all_streams.diff

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 03 Jun 2011 23:20:11 +0200

spark (2010.0.deb-3) unstable; urgency=low

  * Complete port of checker to SWI prolog and enable it
  * Fix defect detection functions in simplifier and fix remaining
    defects

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 03 Jun 2011 12:58:37 +0200

spark (2010.0.deb-2) unstable; urgency=low

  * Add Vcs-* fields to debian/control
  * New patches:
    - sparklarl-redundant-conversion.diff: remove reduntant conversions to
      File_Type. This causes warnings with gnat-4.6
    - examiner-useless-assignment.diff: remove useless assignment of a
      variable to itself
    - examiner-redundant-conversion.diff: remove redundant conversion to
      Integer
  * Standards-Version 3.9.2 — no changes required

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 02 May 2011 10:27:57 +0200

spark (2010.0.deb-1) unstable; urgency=low

  * Initial release (Closes: #617551)

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 27 Mar 2011 22:14:12 +0200

=== debian/control ===
Source: spark
Section: devel
Priority: optional
Maintainer: Євгеній Мещеряков <eugen@debian.org>
Build-Depends: debhelper (>= 8), gnat, swi-prolog-nox (>= 5.10.4~), libgmp-dev (>= 2:5.0.1+dfsg-7~), bison, flex
Standards-Version: 3.9.2
Homepage: http://libre.adacore.com/libre/tools/spark-gpl-edition/
Vcs-Git: git://git.debian.org/collab-maint/spark.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/spark.git

Package: spark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, swi-prolog-nox (>= 5.10.4~)
Suggests: gnat, alt-ergo
Description: SPARK programming language toolset
 SPARK is a formally-defined computer programming language based on the
 Ada programming language, intended to be secure and to support the
 development of high integrity software used in applications and systems
 where predictable and highly reliable operation is essential either for
 reasons of safety or for business integrity.
 .
 This package contains the tools necessary for checking if programs adhere
 to the SPARK rules and the tools to show freedom of runtime exceptions in
 those programs. To compile SPARK programs use any standards-compliant Ada
 compiler, such as GNAT.

=== debian/rules ===
#!/usr/bin/make -f

CXXFLAGS = -g -Wall
LDFLAGS = -g -Wall

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CXXFLAGS += -O0
	ADA_OPT = -O0
else
	CXXFLAGS += -O2
	LDFLAGS += -O2
	ADA_OPT = -O2
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	GNATMAKE_PAR = -j$(NUMJOBS)
endif

export CXXFLAGS LDFLAGS ADA_OPT GNATMAKE_PAR

%:
	dh $@

override_dh_auto_clean:
	$(MAKE) reallycleanall

override_dh_auto_build:
	# create empty directories that can be destroyed by git
	mkdir -p victor/vct/bin
	mkdir -p bin
	mkdir -p share/spark

	dh_auto_build CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	# nothing

override_dh_auto_test:
	# nothing
